#UARTinterr:
    # There is space on _uart_buff
    # _uart_buff[0]=UARTstatus, [1]=UARTcontrol, [2]=data_inp, [3]=new,
    #           [4]=$ra, [5]=$a0, [6]=$a1, [7]=$a2, [8]=$a3
    #k0 = _uart_buff

    # saving used registers on _uart_buff
    
    sw    $a2, 7*4($k0)
    sw    $a3, 8*4($k0)
    sw    $v0, 9*4($k0)

    jal disableInterr   #$v0 = status
    nop

    andi  $a1, $k1, UART_rx_irq # Is this reception?
    beq   $a1, $zero, UARTrxinter #   no, maybe transmission?
    nop
    andi  $a1, $k1, UART_tx_irq # Is this transmission?
    bne   $a1, $zero, UARTret     #   no, it was nothing
    nop

    lui   $a2, %hi(ntx)
    ori   $a2, $a2, %lo(ntx)
    lw    $a1, 0($a2)

    li    $a3, 16
    beq   $a3, $a1, overrun     # empty Q
    nop

    addi  $a1, $a1, 1
    sw    $a1, 0($a2)           # update ntx, one more free space

    # STORE AND THEN INCREMENTS
    lui   $a2, %hi(tx_q)
    ori   $a2, $a2, %lo(tx_q)
    
    lui   $a1, %hi(tx_hd)
    ori   $a1, $a1, %lo(tx_hd)
    lw    $a3, 0($a1)
    nop
    add   $a2, $a2, $a3         # a2 <- &(tx_q[tx_hd])
    lb    $a3, 0($a2)           # get char from Q head
    nop
    addi  $a3, $a3, 1           #increment Q head
    andi  $a3, $a3, 0xf         # modulo 16
    sw    $a3, 0(a1)            # store new head index

    sw    $a2, 0(a0)            # write char in txreg


endHU: 
    
    jal   enableInterr
    nop
    lw    $v0, 9*4($k0)
    lw    $a3, 8*4($k0)
    b     UARTret
    lw    $a2, 7*4($k0)

UARTrxinter:
    #handle reception
    lw    $a1, 4($a0)           # Read data from device
    nop                         #   and store it to UART's buffer
    sw    $a1, 2*4($k0)         #   and return from interrupt
    addiu $a1, $zero, 1
    sw    $a1, 3*4($k0)         # Signal new arrival
                                # Jedian: when a new char is on the UART's buffer, 
                                #         i have to enqueue it and update nrx.
    
    # check if queue is full, maybe increment
    lui   $5, %hi(nrx)
    ori   $5, $5, %lo(nrx)
    lw    $7, 0($5)
    nop
    slti  $6, $7, 16
    beq   $6, $zero, overrun
    nop
    addiu $7, $7, 1
    sw    $7, 0($5)

    # enqueue
    lui   $5, %hi(rx_tl)        # get rx tail address
    ori   $5, $5, %lo(rx_tl)    

    lw    $7, 0($5)
    nop
    addiu $7, $7, 1             # increment in 1 the tail of the circular queue
    andi  $7, $7, 0xf           # % 16
    sw    $7, 0($5)

    #### stores on queue on tail
    lui   $6, %hi(rx_q)         # get queue address
    ori   $6, $6, %lo(rx_q)

    addu  $6, $7, $6            # calculate address to move new char
    lw    $7, 2*4($k0)          # get char to be stored
    nop
    sb    $7, 0($6)             # and store it!

    b endUH
    nop

overrun:
    # do something if rx queue is full or tx is empty
    # set overrun bit on uart statusReg
    #... (doing absolutely nothing besides stacking and unstacking regs)
    lw $a1, 0*4($k0)            # get status from memory
    nop
    andi $a1, $a1, 0xFFFFFFF1   # set overun bit to 1 
    # sw $a1, ???   ---+          Dunno where to save Status
    b endUH         #  |
    nop         #   <--+

